"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createFileModelModifier = exports.CmsModelModifierPlugin = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _plugins = require("@webiny/plugins");
var _file = require("../cmsFileStorage/file.model");
var _createModelField = require("../cmsFileStorage/createModelField");
class CmsModelFieldsModifier {
  constructor(fields) {
    (0, _defineProperty2.default)(this, "fields", void 0);
    this.fields = fields;
  }
  addField(field) {
    this.fields.push((0, _objectSpread2.default)((0, _objectSpread2.default)({}, field), {}, {
      storageId: `${field.type}@${field.id}`
    }));
  }
}
class CmsModelModifierPlugin extends _plugins.Plugin {
  constructor(modelId, cb) {
    super();
    (0, _defineProperty2.default)(this, "modelId", void 0);
    (0, _defineProperty2.default)(this, "cb", void 0);
    this.modelId = modelId;
    this.cb = cb;
  }
  async modifyModel(model) {
    if (model.modelId !== this.modelId) {
      return;
    }
    let extensionsField = model.fields.find(field => field.fieldId === "extensions");
    if (!extensionsField) {
      extensionsField = (0, _createModelField.createModelField)({
        label: "Extensions",
        type: "object",
        settings: {
          layout: [],
          fields: []
        }
      });
      model.fields.push(extensionsField);
    }
    const modifier = new CmsModelFieldsModifier(extensionsField.settings.fields);
    await this.cb({
      modifier
    });
  }
}
exports.CmsModelModifierPlugin = CmsModelModifierPlugin;
(0, _defineProperty2.default)(CmsModelModifierPlugin, "type", "fm.cms-model-modifier");
const createFileModelModifier = cb => {
  return new CmsModelModifierPlugin(_file.FILE_MODEL_ID, cb);
};
exports.createFileModelModifier = createFileModelModifier;